import template from "./index.html"

let keyboard = {

    props: {
        type: {
            type: String,
            default: 'pay'
        },
        isOk: {
            type: Boolean,
            default: true
        },
        show: {
            type: Boolean,
            default: true
        },
        disabled: {
            type: Boolean,
            default: false
        },
        value: {
            type: String,
            default: ''
        },
        text: {
            type: String,
            default: "支付"
        },
        bgcolor: {
            type: String,
            default: "#1AAD19"
        },
        textcolor: {
            type: String,
            default: "#fff"
        },
        fixHeight:{
            type: Number,
            default: 0
        },
        len: {
            type: Number,
            default: 5
        },
        max: {
            type: Number,
            default: null
        },
        min: {
            type: Number,
            default: 5
        }
    },
    template,
    watch: {
        disabled(val) {
            this.bgcolors = val ? '#ddd' : this.bgcolor
        },
        show() {
            this.str = this.value;
            setTimeout(() => {
                this.setkeyboardtop()
            }, 100)
        },
        'value':{
            handler: function() {
                if(this.value){
                    this.str = this.value;
                }else{
                    this.str = '';
                }

            }
        }
    },
    data() {
        return {
            str: "",
            delinterval: '',
            onebyoneInterval: "",
            bgcolors: '',
            target: '',
            width: 0,
            dw: 0,
            dh: 0
        };
    },
    methods: {
        //设置str 主要用在需要判断最大值的大小的时候超出了限制
        setStr(val){
            this.str = val;
        },
        // 按下效果
        numberstart(e) {
            this.target = e.target.tagName == 'I' ? e.target.parentNode : e.target
            this.target.className = this.target.className + ' active'
            setTimeout(() => {
                let classname = this.target.className
                if (classname.indexOf('active') != -1) {
                    this.target.className = classname.substr(0, classname.length - 6)
                }
            }, 100)
        },
        getType(obj){
            //tostring会返回对应不同的标签的构造函数
            var toString = Object.prototype.toString;
            var map = {
                '[object Boolean]'  : 'boolean',
                '[object Number]'   : 'number',
                '[object String]'   : 'string',
                '[object Function]' : 'function',
                '[object Array]'    : 'array',
                '[object Date]'     : 'date',
                '[object RegExp]'   : 'regExp',
                '[object Undefined]': 'undefined',
                '[object Null]'     : 'null',
                '[object Object]'   : 'object'
            };
            if(obj instanceof Element) {
                return 'element';
            }
            return map[toString.call(obj)];
        },
        deepClone(data){
            var type = this.getType(data);
            var obj;
            if(type === 'array'){
                obj = [];
            } else if(type === 'object'){
                obj = {};
            } else {
                //不再具有下一层次
                return data;
            }
            if(type === 'array'){
                for(var i = 0, len = data.length; i < len; i++){
                    obj.push(deepClone(data[i]));
                }
            } else if(type === 'object'){
                for(var key in data){
                    obj[key] = deepClone(data[key]);
                }
            }
            return obj;
        },
        clicknumberfun(e, val) {
            e.preventDefault()
            this.numberstart(e)
            const oldStr = this.deepClone(this.str);
            //console.log(oldStr);
            navigator.vibrate ? navigator.vibrate(50) : (navigator.webkitVibrate ? navigator.webkitVibrate(50) : '')
            if (this.type == 'pay') {
                // 判断有效数字 前置为去掉多余的0
                if (val === ".") {
                    if (this.str.length === 0) {
                        this.str = "0";
                    } else {
                        if (this.str.indexOf(".") != -1) {
                            val = "";
                        }
                    }
                    this.str += val;
                    this.str = Number(this.str.split('.')[0]) + '.' + (this.str.split('.')[1] ? this.str.split('.')[1] : '')
                } else {
                    if(this.str || this.str == 0){
                        if (this.str.indexOf('.') === -1) {
                            this.str = Number(this.str).toString() == '0' ? '' : Number(this.str).toString()
                        } else {
                            if (this.str.split('.')[0].length >= 1) {
                                this.str = Number(this.str.split('.')[0]) + '.' + (this.str.split('.')[1] ? this.str.split('.')[1] : '')
                            }
                        }
                        if (this.str.indexOf(".") == -1 && this.str.length >= this.len) {
                            val = "";
                        }
                        if (this.str.split(".")[1] && this.str.split(".")[1].length >= 2) {
                            val = "";
                        }
                        this.str += val;
                    }else{
                        this.str = val;
                    }
                }
            } else if (this.type == 'phone') {
                if (val == '.' || this.str.length >= this.len) {
                    val = ''
                }
                var curStr = this.str + val;
                if(this.max){
                    if(Number(curStr)<=this.max){
                        this.str = curStr;
                    }else{
                        this.str = Number(this.max).toString();
                    }
                }else{
                    this.str = curStr;
                }
            } else if (this.type == 'sfz') {
                if (this.str.length >= this.len) {
                    val = ''
                }
                var curStr = this.str + val;
                if(this.max){
                    if(Number(curStr)<=this.max){
                        this.str = curStr;
                    }else{
                        this.str = Number(this.max).toString();
                    }
                }else{
                    this.str = curStr;
                }
            } else if (this.type == 'int') {
                if(Number(this.str).toString()=='NaN'){
                    this.str = "0";
                }
                if (val == '.' || this.str.length >= this.len) {
                    val = ''
                }

                var curStr = this.str + val;
                if(this.max){
                    if(Number(curStr)<=this.max){
                        this.str = curStr;
                    }else{
                        this.$emit("error", 'max');
                        //this.str = Number(this.max).toString();
                    }
                }else{
                    this.str = curStr;
                }
                //this.str += val;
            }
            // if(this.max){
            //     if(this.str>this.max){
            //         this.str = this.oldStr;
            //     }
            // }
            this.$emit("callback", this.str);
        },
        delall(e) {
            if(this.type == 'int'){
                this.str = "0";
            }else{
                this.str = "0";
            }
            this.numberstart(e)
            e.preventDefault()
            navigator.vibrate ? navigator.vibrate(50) : (navigator.webkitVibrate ? navigator.webkitVibrate(50) : '')
            this.$emit("callback", this.str,'delall');
        },
        delonestart(e) {
            this.numberstart(e)
            e.preventDefault()
            navigator.vibrate ? navigator.vibrate(50) : (navigator.webkitVibrate ? navigator.webkitVibrate(50) : '')
            if (this.str.length > 0) {
                this.str = this.str.substr(0, this.str.length - 1);
                console.log(typeof(this.str));
                console.log(this.str);


                if(this.str==''){
                    this.str='0';
                }
                this.$emit("callback", this.str,'del');
                this.delinterval = setTimeout(() => {
                    this.delonebyone()
                }, 500)
            }
        },
        deloneend() {
            if(this.str==''){
                this.str=0;
            }
            this.$emit("delend", this.str,'delall');
            clearTimeout(this.delinterval)
            clearInterval(this.onebyoneInterval)
        },
        delonebyone() {
            if (this.str.length > 0) {
                this.onebyoneInterval = setInterval(() => {
                    if (this.str.length == 0) {
                        clearInterval(this.onebyoneInterval)
                        return
                    }
                    this.str = this.str.substr(0, this.str.length - 1);
                    this.$emit("callback", this.str,'del');
                }, 100)
            }
        },
        pay() {
            if (this.disabled) return
            navigator.vibrate ? navigator.vibrate(50) : (navigator.webkitVibrate ? navigator.webkitVibrate(50) : '')
            if (this.type == 'pay' && this.str.length > 0) {
                if (this.str.indexOf(".") != -1) {
                    if (!this.str.split(".")[1]) {
                        this.str += "00";
                    } else if (this.str.split(".")[1].length === 1) {
                        this.str += "0";
                    }
                } else {
                    this.str += ".00";
                }
            }
            this.$emit("callback", this.str);
            this.$emit("paycallback");
        },
        setkeyboardtop() {
            var addonHeight = 0;
            if(this.fixHeight>0){
                addonHeight = this.fixHeight;
            }else{
                addonHeight = this.$refs.addon.offsetHeight;
            }
            let keyboard = this.$refs.keyboard_id
            keyboard.style.height = this.width * 0.618 + addonHeight + 'px'
            let kh = this.show ? this.width * 0.618 : 0
            if(this.show){
                keyboard.style.bottom = '0px'
            }else{
                keyboard.style.bottom = '-1000px'
            }
            let span = keyboard.querySelectorAll('.textstyle')
            span.forEach(item => {
                item.style.width = this.dw + 'px'
                item.style.height = this.dh + 'px'
                item.style.lineHeight = this.dh + 'px'
                if (item.id == 'paybtn') {
                    item.style.height = this.dh * 3 + 'px'
                    item.style.lineHeight = this.dh * 3 + 'px'
                }
            })
        },
        close(){
            if (this.disabled) return
            navigator.vibrate ? navigator.vibrate(50) : (navigator.webkitVibrate ? navigator.webkitVibrate(50) : '')
            if (this.type == 'pay' && this.str.length > 0) {
                if (this.str.indexOf(".") != -1) {
                    if (!this.str.split(".")[1]) {
                        this.str += "00";
                    } else if (this.str.split(".")[1].length === 1) {
                        this.str += "0";
                    }
                } else {
                    this.str += ".00";
                }
            }
            this.$emit("close", this.str);
        }
    },
    created() {
        // document.documentElement.style.fontSize = document.documentElement.clientWidth / 7.5 + "px";
        if(this.value){
            this.str = this.value
        }else{
            this.str = ''
        }
        this.bgcolors = this.disabled ? '#ddd' : this.bgcolor
    },
    mounted() {
        this.width = document.documentElement.clientWidth
        this.dw = this.width / 4
        this.dh = this.dw * 0.618
        this.$nextTick(() => {
            this.setkeyboardtop()
        })
    }
}

keyboard.install = function (Vue, name = 'keyboardNumber') {
    Vue.component(name, keyboard);
}

export default keyboard;
